#ifndef __TIMER_H__
#define __TIMER_H__


// High performance timer class
class CTimer
{
public:

	// Starts or unpauses the timer
	void Start();

	// Stops or pauses the timer
	void Stop();

	// Stops and resets the timer
	void Reset();

	// Return the total time from last reset
	double GetTime() const;
	
	// Returns the elapsed time between successive calls to GetElapsedTime()
	double GetElapsedTime();

	// Returns true if the timer initialized correctly
	bool IsInitialized() const	{ return initialized; }

	// Returns true if the timer is running
	bool IsRunning() const		{ return !stopped; }

	// ctor/dtor
	CTimer();
	~CTimer();

protected:
	bool reset, stopped, initialized;
	double rate_inv;
	__int64 startTime;
	__int64 savedTime;
	__int64 stopTime;
	__int64 lastTime;

};


#endif //__TIMER_H__