#ifndef __DISPLACEMENTMAP_H__
#define __DISPLACEMENTMAP_H__

#ifdef WIN32
	#define WIN32_LEAN_AND_MEAN
	#define WIN32_EXTRA_LEAN
	#include <windows.h>
#endif

#include <gl/glee.h>


// Implements a mutable height map
class CDisplacementMap
{
public:

	CDisplacementMap();
	~CDisplacementMap();

	// Initializes the texture
	bool Initialize( int width, int height );

	// Frees the texture memory
	void Destroy();

	// Update GL's copy of the texture
	void Refresh();

	// Makes this map the active GL texture
	void Bind( bool bUseATIFloat );

	// Adds a dab of "paint" at the given UV coord
	void Paint( float u, float v );

	// Query for a height value
	GLfloat GetHeightAt( float u, float v );

private:

	GLfloat *m_pPixels;
	int m_nWidth, m_nHeight, m_nImgSize;
	GLuint m_nStdTexID, m_nATITexID;

};

#endif //__DISPLACEMENTMAP_H__
